SystemOrganization addCategory: #'Magritte-Morph-Model'!

!MAMultipleOptionDescription class methodsFor: '*magritte-morph-defaults' stamp: 'lr 12/24/2005 12:56'!
defaultMorphClasses
	^ Array with: MAMultiSelectListMorph.! !

!MASingleOptionDescription class methodsFor: '*magritte-morph-defaults' stamp: 'lr 12/24/2005 12:56'!
defaultMorphClasses
	^ Array with: MASingleSelectListMorph.! !

!MAContainer class methodsFor: '*magritte-morph-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultMorphClasses
	^ Array with: MAContainerMorph.! !

!MAContainer methodsFor: '*magritte-morph-converting' stamp: 'lr 10/10/2005 20:29'!
asMorphOn: anObject
	^ self morphClass
		memento: (anObject mementoClass 
			model: anObject 
			description: self).! !

!Object methodsFor: '*magritte-morph-converting' stamp: 'lr 5/8/2005 20:29'!
asMorph
	^ self description asMorphOn: self.! !

!MAFileDescription class methodsFor: '*magritte-morph-defaults' stamp: 'lr 1/18/2006 14:43'!
defaultMorphClasses
	^ Array with: MAFileMorph.! !

!MAMemoDescription class methodsFor: '*magritte-morph-defaults' stamp: 'lr 1/18/2006 14:29'!
defaultMorphClasses
	^ Array with: MAMemoMorph.! !

Model subclass: #MADescriptionMorph
	instanceVariableNames: 'memento description parent morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

MADescriptionMorph subclass: #MAContainerMorph
	instanceVariableNames: 'children answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAContainerMorph methodsFor: 'decorating' stamp: 'lr 10/10/2005 20:33'!
addButtons
	self addButtons: #( save cancel ).! !

!MAContainerMorph methodsFor: 'decorating' stamp: 'lr 1/9/2006 08:38'!
addButtons: anArray
	morph := self rectangleMorph
		vResizing: #shrinkWrap;
		addMorphBack: self morph;
		addMorphBack: (self barMorph: anArray);
		yourself.! !

!MAContainerMorph methodsFor: 'decorating' stamp: 'lr 1/9/2006 08:37'!
addWindow
	morph := self windowMorph
		model: self;
		vResizing: #shrinkWrap;
		addMorph: (self morph layoutInset: 5 @ 5)
			frame: (0 @ 0 corner: 1 @ 1);
		yourself.! !

!MAContainerMorph methodsFor: 'answering' stamp: 'lr 10/10/2005 20:45'!
answer: anObject
	answer ifNotNil: [ answer value: anObject ].
	self morph delete.! !

!MAContainerMorph methodsFor: 'private' stamp: 'lr 10/10/2005 21:09'!
buildChildren
	^ Array streamContents: [ :stream |
		self description do: [ :each |
			each isVisible ifTrue: [
				stream nextPut: (each morphClass
					memento: self memento
					description: each
					parent: self) ] ] ].! !

!MAContainerMorph methodsFor: 'private' stamp: 'lr 10/10/2005 21:02'!
buildMorphView
	| result |
	result := self rectangleMorph
		setBalloonText: self description comment;
		listDirection: #topToBottom;
		cellInset: 3;
		yourself.
	self children do: [ :each |
		result addMorphBack: each morph ].
	^ result.! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'lr 1/1/2006 22:27'!
callInHand
	| result |
	result := nil.
	self onAnswer: [ :value | result := value ].
	self openInHand; waitUntilClosed.
	^ result.! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'lr 1/1/2006 22:27'!
callInWorld
	| result |
	result := nil.
	self onAnswer: [ :value | result := value ].
	self openInWorld; waitUntilClosed.
	^ result.! !

!MAContainerMorph methodsFor: 'actions' stamp: 'lr 10/10/2005 20:32'!
cancel
	self reset; answer: nil.! !

!MAContainerMorph methodsFor: 'accessing' stamp: 'lr 11/1/2005 20:28'!
children
	^ children! !

!MAContainerMorph methodsFor: 'answering' stamp: 'lr 10/10/2005 20:45'!
onAnswer: aBlock
	answer := aBlock! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'lr 10/10/2005 20:44'!
openInHand
	^ self morph openInHand.! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'lr 10/10/2005 20:45'!
openInWorld
	^ self morph openInWorld.! !

!MAContainerMorph methodsFor: 'actions' stamp: 'lr 11/1/2005 21:44'!
save
	[ self validate ]
		on: MAValidationError 
		do: [ :err | ^ self inform: err asString ].
	self commit; answer: self model.! !

!MAContainerMorph methodsFor: 'initialization' stamp: 'lr 11/1/2005 20:29'!
setChildren: aCollection
	children := aCollection! !

!MAContainerMorph methodsFor: 'initialization' stamp: 'lr 11/1/2005 20:28'!
setDescription: aDescription
	super setDescription: aDescription.
	self setChildren: self buildChildren.! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'lr 10/10/2005 21:06'!
waitUntilClosed
	[ self morph world notNil ] 
		whileTrue: [ self morph outermostWorldMorph doOneCycle ].! !

!MADescriptionMorph class methodsFor: 'instance creation' stamp: 'lr 10/10/2005 20:27'!
memento: aMemento
	^ self memento: aMemento description: aMemento description.! !

!MADescriptionMorph class methodsFor: 'instance creation' stamp: 'lr 10/10/2005 20:27'!
memento: aMemento description: aDescription
	^ self memento: aMemento description: aDescription parent: nil.! !

!MADescriptionMorph class methodsFor: 'instance creation' stamp: 'lr 10/10/2005 20:28'!
memento: aMemento description: aDescription parent: aComponent
	^ self new
		setMemento: aMemento;
		setDescription: aDescription;
		setParent: aComponent;
		yourself.! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 5/8/2005 20:30'!
barMorph: anArray
	| bar |
	bar := self rectangleMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		listDirection: #leftToRight;
		listCentering: #center;
		wrapCentering: #bottomRight;
		cellInset: self defaultSpacerSize;
		yourself.
	anArray do: [ :selector |
		bar addMorphBack: (self buttonMorph: selector) ].
	^ bar.! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 10/13/2005 17:53'!
buildMorph
	^ self description isReadonly
		ifTrue: [ self buildMorphView ]
		ifFalse: [ self buildMorphEditor ].! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 10/10/2005 20:48'!
buildMorphEditor
	^ self buildMorphView.! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 11/20/2005 23:18'!
buildMorphView
	self subclassResponsibility.! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 5/8/2005 20:30'!
buttonMorph: aSelector
	| button |
	button := PluggableButtonMorph
		on: self 
		getState: #buttonState 
		action: aSelector.
	button
		label: aSelector;
		shortcutCharacter: aSelector first;
		onColor: Color transparent offColor: Color white;
		useRoundedCorners;
		borderWidth: 2;
		borderColor: #raised.
	^ button.! !

!MADescriptionMorph methodsFor: 'old' stamp: 'lr 5/8/2005 20:30'!
buttonState
	^ true! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 11/1/2005 21:45'!
commit
	self memento commit.! !

!MADescriptionMorph methodsFor: 'accessing-configuration' stamp: 'lr 5/8/2005 20:30'!
defaultBackgroundColor
	^ self description morphColor.! !

!MADescriptionMorph methodsFor: 'accessing-configuration' stamp: 'lr 5/8/2005 20:30'!
defaultSpacerSize
	^ 5! !

!MADescriptionMorph methodsFor: 'accessing' stamp: 'lr 10/10/2005 20:23'!
description
	^ description! !

!MADescriptionMorph methodsFor: 'accessing' stamp: 'lr 10/10/2005 20:24'!
memento
	^ memento! !

!MADescriptionMorph methodsFor: 'accessing-dynamic' stamp: 'lr 10/10/2005 20:24'!
model
	^ self memento model.! !

!MADescriptionMorph methodsFor: 'accessing' stamp: 'lr 11/1/2005 20:58'!
morph
	^ morph ifNil: [ morph := self buildMorph ].! !

!MADescriptionMorph methodsFor: 'accessing' stamp: 'lr 10/10/2005 20:24'!
parent
	^ parent! !

!MADescriptionMorph methodsFor: 'old' stamp: 'lr 5/8/2005 20:30'!
perform: selector orSendTo: otherTarget
	^ (self respondsTo: selector)
		ifTrue: [ self perform: selector ]
		ifFalse: [ otherTarget perform: selector ].! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 5/8/2005 20:30'!
rectangleMorph
	^ RectangleMorph new
		borderWidth: 0;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellPositioning: #topLeft;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		yourself.! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 10/10/2005 20:24'!
reset
	self memento reset.! !

!MADescriptionMorph methodsFor: 'accessing-dynamic' stamp: 'lr 10/10/2005 20:24'!
root
	^ self parent isNil 
		ifTrue: [ self ]
		ifFalse: [ self parent root ].! !

!MADescriptionMorph methodsFor: 'initialization' stamp: 'lr 10/10/2005 20:25'!
setDescription: aDescription
	description := aDescription! !

!MADescriptionMorph methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setMemento: aMemento
	memento := aMemento! !

!MADescriptionMorph methodsFor: 'initialization' stamp: 'lr 10/10/2005 20:25'!
setParent: aMorph
	parent := aMorph! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 5/8/2005 20:30'!
stringMorph
	^ StringMorph new.! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 11/1/2005 21:46'!
validate
	"Flushes the cached state of some morphic elements (such as text-morphs) to the memento and then does the validation. I don't know of a better flush the morphic contents (happy flickering), probably morphic is just too limited to customize that easily or I am too dumb to find out."

	self morph allMorphsDo: [ :each |
		(each respondsTo: #accept)
			ifTrue: [ each accept ] ].
	self memento validate.! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 5/8/2005 20:30'!
windowMorph
	^ SystemWindow labelled: self description label.! !

MADescriptionMorph subclass: #MAElementMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

MAElementMorph subclass: #MACheckboxMorph
	instanceVariableNames: 'checkbox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MACheckboxMorph methodsFor: 'private' stamp: 'lr 1/9/2006 08:20'!
buildMorphEditor
	^ checkbox := ThreePhaseButtonMorph checkBox
		target: self; 
		actionSelector: #toggle;
		state: self state;
		yourself.! !

!MACheckboxMorph methodsFor: 'accessing' stamp: 'lr 1/9/2006 08:21'!
checkbox
	^ checkbox! !

!MACheckboxMorph methodsFor: 'actions' stamp: 'lr 1/9/2006 08:16'!
state
	^ (self value ifNil: [ self description default ])
		ifTrue: [ #on ] ifFalse: [ #off ].! !

!MACheckboxMorph methodsFor: 'actions' stamp: 'lr 1/9/2006 08:20'!
toggle
	self value: self value not.
	self checkbox state: self state.! !

!MAElementMorph methodsFor: 'private' stamp: 'lr 10/10/2005 21:09'!
buildMorph
	| result |
	result := self rectangleMorph
		layoutInset: 1 @ 1;
		listDirection: #leftToRight;
		addMorphBack: self buildMorphLabel;
		addMorphBack: super buildMorph;
		yourself.
	self description hasComment 
		ifTrue: [ result setBalloonText: self description comment ].
	self description isRequired
		ifTrue: [ result addMorphBack: self buildMorphRequired ].
	^ result.! !

!MAElementMorph methodsFor: 'private' stamp: 'lr 10/10/2005 20:52'!
buildMorphLabel
	^ self stringMorph
		contents: self description label , ':';
		width: 100;
		yourself.! !

!MAElementMorph methodsFor: 'private' stamp: 'lr 10/10/2005 20:52'!
buildMorphRequired
	^ self stringMorph
		contents: ' *';
		color: Color red;
		yourself.! !

!MAElementMorph methodsFor: 'private' stamp: 'lr 10/10/2005 20:50'!
buildMorphView
	^ self stringMorph 
		contents: self string; 
		yourself.! !

!MAElementMorph methodsFor: 'accessing' stamp: 'lr 10/10/2005 21:16'!
string
	^ self description toString: self value.! !

!MAElementMorph methodsFor: 'accessing' stamp: 'lr 11/1/2005 21:30'!
string: aString
	| value |
	value := [ self description fromString: aString asString ]
		ifError: [ aString ].
	self value: value; changed: #string.! !

!MAElementMorph methodsFor: 'accessing' stamp: 'lr 10/10/2005 20:51'!
value
	^ self memento readUsing: self description.! !

!MAElementMorph methodsFor: 'accessing' stamp: 'lr 10/10/2005 20:57'!
value: anObject
	self memento write: anObject using: self description.
	self changed: #value.! !

MAElementMorph subclass: #MAFileMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAFileMorph methodsFor: 'private' stamp: 'lr 1/18/2006 14:54'!
buildMorphEditor
	^ self buttonMorph: #choose.! !

!MAFileMorph methodsFor: 'actions' stamp: 'lr 1/18/2006 14:52'!
choose
	| stream |
	stream := FileList2 modalFileSelector.
	stream isNil ifFalse: [
		stream binary.
		self value: (self description kind new
			contents: stream contents;
			filename: stream localName) ].
			! !

MAElementMorph subclass: #MAListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAListMorph methodsFor: 'accessing-dynamic' stamp: 'lr 12/24/2005 12:16'!
options
	^ self description allOptions.! !

!MAListMorph methodsFor: 'accessing-dynamic' stamp: 'lr 12/24/2005 13:04'!
strings
	^ self options collect: [ :each | self description reference toString: each ].! !

MAListMorph subclass: #MAMultiSelectListMorph
	instanceVariableNames: 'selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAMultiSelectListMorph methodsFor: 'private' stamp: 'lr 12/24/2005 15:45'!
buildMorphEditor
	^ (PluggableListMorphOfMany on: self list: #strings primarySelection: #selected changePrimarySelection: #selected: listSelection: #selectionAt: changeListSelection: #selectionAt:put: menu: nil)
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 2;
		yourself.! !

!MAMultiSelectListMorph methodsFor: 'accessing' stamp: 'lr 12/24/2005 15:43'!
selected
	^ selected ifNil: [ selected := 0 ].! !

!MAMultiSelectListMorph methodsFor: 'accessing' stamp: 'lr 12/24/2005 15:43'!
selected: anInteger
	selected := anInteger.
	self changed: #selected.! !

!MAMultiSelectListMorph methodsFor: 'accessing' stamp: 'lr 12/24/2005 12:59'!
selectionAt: anInteger
	^ self value includes: (self options at: anInteger).! !

!MAMultiSelectListMorph methodsFor: 'accessing' stamp: 'lr 12/24/2005 15:53'!
selectionAt: anInteger put: aBoolean 
	| option |
	option := self options at: anInteger.
	self value: (aBoolean 
		ifTrue: [ self value copyWith: option ]
		ifFalse: [ self value copyWithout: option ]).
	self changed: #selected.! !

MAListMorph subclass: #MASingleSelectListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MASingleSelectListMorph methodsFor: 'private' stamp: 'lr 12/24/2005 12:57'!
buildMorphEditor
	^ (PluggableListMorph on: self list: #strings selected: #selected changeSelected: #selected:)
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 2;
		yourself.! !

!MASingleSelectListMorph methodsFor: 'accessing' stamp: 'lr 12/24/2005 12:57'!
selected
	^ self options indexOf: self value.! !

!MASingleSelectListMorph methodsFor: 'accessing' stamp: 'lr 12/24/2005 12:57'!
selected: anInteger
	self value: (self options at: anInteger ifAbsent: [ nil ]).
	self changed: #selected.! !

MAElementMorph subclass: #MAMemoMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAMemoMorph methodsFor: 'accessing' stamp: 'lr 1/18/2006 14:29'!
annotation
	^ self string.! !

!MAMemoMorph methodsFor: 'private' stamp: 'lr 1/18/2006 14:28'!
buildMorphEditor
	"The selector #annotation should be #string instead, but we use this one and dispatch since this prevents morphic to draw a thin red border around changed fields. Stupid hack, really, but doesn't work otherwise."
	
	^ (PluggableTextMorph on: self text: #annotation accept: #string:)
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 2;
		yourself.! !

MAMemoMorph subclass: #MATextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

MATextMorph subclass: #MAPasswordMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAPasswordMorph methodsFor: 'private' stamp: 'lr 1/9/2006 08:30'!
buildMorphEditor
	^ super buildMorphEditor
		font: (StrikeFont passwordFontSize: 12);
		yourself.! !

!MATextMorph methodsFor: 'private' stamp: 'lr 1/18/2006 14:28'!
buildMorphEditor
	^ super buildMorphEditor
		hideScrollBarsIndefinitely: true;
		acceptOnCR: true;
		height: 20;
		yourself.

! !

!MADescription class methodsFor: '*magritte-morph-defaults' stamp: 'lr 8/11/2005 09:52'!
defaultMorphClass
	^ self defaultMorphClasses notEmpty
		ifTrue: [ self defaultMorphClasses first ].! !

!MADescription class methodsFor: '*magritte-morph-defaults' stamp: 'lr 8/11/2005 09:48'!
defaultMorphClasses
	^ Array new.! !

!MADescription class methodsFor: '*magritte-morph-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultMorphColor
	^ Color r: 0.151 g: 0.327 b: 0.720.! !

!MADescription class methodsFor: '*magritte-morph-description' stamp: 'lr 9/26/2005 09:47'!
descriptionMorphClass
	^ (MASingleOptionDescription selector: #morphClass label: 'Morph Class' priority: 2000)
		reference: MAClassDescription new;
		options: self defaultMorphClasses;
		default: self defaultMorphClass;
		yourself.! !

!MADescription methodsFor: '*magritte-morph-accessing' stamp: 'lr 5/8/2005 20:30'!
morphClass
	^ self propertyAt: #morphClass ifAbsent: [ self class defaultMorphClass ].! !

!MADescription methodsFor: '*magritte-morph-accessing' stamp: 'lr 5/8/2005 20:30'!
morphClass: aClass
	^ self propertyAt: #morphClass put: aClass.! !

!MADescription methodsFor: '*magritte-morph-accessing' stamp: 'lr 5/8/2005 20:30'!
morphColor
	^ self propertyAt: #morphColor ifAbsent: [ self class defaultMorphColor ].! !

!MADescription methodsFor: '*magritte-morph-accessing' stamp: 'lr 5/8/2005 20:30'!
morphColor: aColor
	^ self propertyAt: #morphColor put: aColor.! !

!MAElementDescription class methodsFor: '*magritte-morph-defaults' stamp: 'lr 1/18/2006 10:52'!
defaultMorphClasses
	^ Array with: MATextMorph.! !

!MAPasswordDescription class methodsFor: '*magritte-morph-default' stamp: 'lr 1/9/2006 08:31'!
defaultMorphClasses
	^ Array with: MAPasswordMorph.! !

!MABooleanDescription class methodsFor: '*magritte-morph-default' stamp: 'lr 1/31/2006 20:15'!
defaultMorphClasses
	^ Array with: MACheckboxMorph with: MASingleSelectListMorph.! !
